﻿using ProjectRepairWork.Repositories;
using ProjectRepairWork.Repositories.Implementation;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using Unity;

namespace ProjectRepairWork.Forms
{
    public partial class FormMaterialProcurements : Form
    {
        private readonly IUnityContainer _container;
        private readonly IMaterialProcurementRepository _materialProcurementRepository;
        public FormMaterialProcurements(IUnityContainer container, IMaterialProcurementRepository materialProcurementRepository)
        {
            InitializeComponent();
            _container = container ?? throw new ArgumentNullException(nameof(container));
            _materialProcurementRepository = materialProcurementRepository ?? throw new ArgumentNullException(nameof(materialProcurementRepository));
        }


        private void LoadList()
        {
            dataGridView.DataSource = _materialProcurementRepository.ReadMaterialProcurement();
            dataGridView.Columns["Id"].Visible = false;
        }




        private void ButtonAdd_Click(object sender, EventArgs e)
        {
            try
            {
                _container.Resolve<FormMaterialProcurement>().ShowDialog();
                LoadList();
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, "Ошибка при добавлении", MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
        }

        private void FormMaterialProcurements_Load_1(object sender, EventArgs e)
        {
            try
            {
                LoadList();
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, "Ошибка при загрузке", MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
        }
    }
}
